import static org.junit.Assert.*;

import java.util.Arrays;

import org.junit.Test;

public class TestComparable {

	@Test
	public void testUncomparableEmployees() {
		/*
		 * Employee does not implement the Comparable interface.
		 */
		Employee alan = new Employee(2);
		Employee mark = new Employee(3);
		Employee tom = new Employee(1);
		Employee[] es = {alan, mark, tom};
		Arrays.sort(es);
		Employee[] expected = {tom, alan, mark};
		assertArrayEquals(expected, es);
	}
	
	@Test
	public void testComparableEmployees_1() {
		/*
		 * CEmployee1 implements the Comparable interface.
		 * Method compareTo compares id's only.
		 */
		CEmployee1 alan = new CEmployee1(2);
		CEmployee1 mark = new CEmployee1(3);
		CEmployee1 tom = new CEmployee1(1);
		alan.setSalary(4500.34);
		mark.setSalary(3450.67);
		tom.setSalary(3450.67);
		CEmployee1[] es = {alan, mark, tom};
		/* When comparing employees,
		 * their salaries are irrelevant.
		 */
		Arrays.sort(es);
		CEmployee1[] expected = {tom, alan, mark};
		assertArrayEquals(expected, es);
	}
	
	@Test
	public void testComparableEmployees_2() {
		/*
		 * CEmployee2 implements the Comparable interface.
		 * Method compareTo first compares salaries, then
		 * compares id's for employees with equal salaries.
		 */
		CEmployee2 alan = new CEmployee2(2);
		CEmployee2 mark = new CEmployee2(3);
		CEmployee2 tom = new CEmployee2(1);
		alan.setSalary(4500.34);
		mark.setSalary(3450.67);
		tom.setSalary(3450.67); 
		CEmployee2[] es = {alan, mark, tom};
		Arrays.sort(es);
		CEmployee2[] expected = {alan, tom, mark};
		assertArrayEquals(expected, es);
	}

}
